#pragma once

#ifdef __FB_WIN32__
	#include "windows.bi"
#endif

#Include "GL/gl.bi"
#include "GL/glu.bi"

#Ifdef __FB_LINUX__
	#include once "crt/long.bi"
#endif

extern "C"

type sfTcpSocket as sfTcpSocket_
type sfCircleShape as sfCircleShape_
type sfSoundBuffer as sfSoundBuffer_
type sfSprite as sfSprite_
type sfContext as sfContext_
type sfMusic as sfMusic_
type sfWindow as sfWindow_

type sfSoundRecorder as sfSoundRecorder_
type sfText as sfText_
type sfTexture as sfTexture_
type sfRenderWindow as sfRenderWindow_
type sfView as sfView_
type sfSound as sfSound_
type sfClock as sfClock_
type sfSoundBufferRecorder as sfSoundBufferRecorder_
type sfPacket as sfPacket_
type sfFtp as sfFtp_
type sfMutex as sfMutex_
type sfFtpDirectoryResponse as sfFtpDirectoryResponse_
type sfThread as sfThread_
type sfRenderTexture as sfRenderTexture_
type sfUdpSocket as sfUdpSocket_
type sfSocketSelector as sfSocketSelector_
type sfShape as sfShape_
type sfTcpListener as sfTcpListener_
type sfRectangleShape as sfRectangleShape_
type sfHttpRequest as sfHttpRequest_
type sfImage as sfImage_
type sfHttpResponse as sfHttpResponse_
type sfVertexArray as sfVertexArray_
type sfShader as sfShader_
type sfHttp as sfHttp_
type sfFtpListingResponse as sfFtpListingResponse_
type sfTransformable as sfTransformable_
type sfFtpResponse as sfFtpResponse_
type sfConvexShape as sfConvexShape_
type sfFont as sfFont_

const CSFML_VERSION_MAJOR = 2
const CSFML_VERSION_MINOR = 1

Type sfBool as long

const sfFalse = 0
const sfTrue = 1

type sfInt8 as byte
type sfUint8 as ubyte
type sfInt16 as short
type sfUint16 as ushort
type sfInt32 as long
type sfUint32 as ulong
type sfInt64 as longint
type sfUint64 as ulongint


type sfTime
	microseconds as sfInt64
end type

extern     sfTime_Zero as sfTime

declare function sfTime_asSeconds(byval time_ as sfTime) as single
declare function sfTime_asMilliseconds(byval time_ as sfTime) as sfInt32
declare function sfTime_asMicroseconds(byval time_ as sfTime) as sfInt64
declare function sfSeconds(byval amount as single) as sfTime
declare function sfMilliseconds(byval amount as sfInt32) as sfTime
declare function sfMicroseconds(byval amount as sfInt64) as sfTime

Declare function sfClock_create() as sfClock ptr
declare function sfClock_copy(byval clock as const sfClock ptr) as sfClock ptr
declare sub sfClock_destroy(byval clock as sfClock ptr)
declare function sfClock_getElapsedTime(byval clock as const sfClock ptr) as sfTime
declare function sfClock_restart(byval clock as sfClock ptr) as sfTime

Type sfInputStreamReadFunc as function(byval data_ as any ptr, byval size as sfInt64, byval userData as any ptr) as sfInt64
type sfInputStreamSeekFunc as function(byval position as sfInt64, byval userData as any ptr) as sfInt64
type sfInputStreamTellFunc as function(byval userData as any ptr) as sfInt64
type sfInputStreamGetSizeFunc as function(byval userData as any ptr) as sfInt64

type sfInputStream
	read as sfInputStreamReadFunc
	seek as sfInputStreamSeekFunc
	tell as sfInputStreamTellFunc
	getSize as sfInputStreamGetSizeFunc
	userData as any ptr
end type

Declare function sfMutex_create() as sfMutex ptr
declare sub sfMutex_destroy(byval mutex as sfMutex ptr)
declare sub sfMutex_lock(byval mutex as sfMutex ptr)
declare sub sfMutex_unlock(byval mutex as sfMutex ptr)

Declare sub sfSleep(byval duration as sfTime)

Declare function sfThread_create(byval function_ as sub(byval as any ptr), byval userData as any ptr) as sfThread ptr
declare sub sfThread_destroy(byval thread as sfThread ptr)
declare sub sfThread_launch(byval thread as sfThread ptr)
declare sub sfThread_wait(byval thread as sfThread ptr)
declare sub sfThread_terminate(byval thread as sfThread ptr)

Type sfVector2i
	x as long
	y as long
end type

type sfVector2u
	x as ulong
	y as ulong
end type

type sfVector2f
	x as single
	y as single
end type

type sfVector3f
	x as single
	y as single
	z as single
end type

Declare sub sfListener_setGlobalVolume(byval volume as single)
declare function sfListener_getGlobalVolume() as single
declare sub sfListener_setPosition(byval position as sfVector3f)
declare function sfListener_getPosition() as sfVector3f
declare sub sfListener_setDirection(byval orientation as sfVector3f)
declare function sfListener_getDirection() as sfVector3f

Type sfSoundStatus as long
enum
	sfStopped
	sfPaused
	sfPlaying
end enum

Declare function sfMusic_createFromFile(byval filename as const zstring ptr) as sfMusic ptr
declare function sfMusic_createFromMemory(byval data_ as const any ptr, byval sizeInBytes as uinteger) as sfMusic ptr
declare function sfMusic_createFromStream(byval stream as sfInputStream ptr) as sfMusic ptr
declare sub sfMusic_destroy(byval music as sfMusic ptr)
declare sub sfMusic_setLoop(byval music as sfMusic ptr, byval loop_ as sfBool)
declare function sfMusic_getLoop(byval music as const sfMusic ptr) as sfBool
declare function sfMusic_getDuration(byval music as const sfMusic ptr) as sfTime
declare sub sfMusic_play(byval music as sfMusic ptr)
declare sub sfMusic_pause(byval music as sfMusic ptr)
declare sub sfMusic_stop(byval music as sfMusic ptr)
declare function sfMusic_getChannelCount(byval music as const sfMusic ptr) as ulong
declare function sfMusic_getSampleRate(byval music as const sfMusic ptr) as ulong
declare function sfMusic_getStatus(byval music as const sfMusic ptr) as sfSoundStatus
declare function sfMusic_getPlayingOffset(byval music as const sfMusic ptr) as sfTime
declare sub sfMusic_setPitch(byval music as sfMusic ptr, byval pitch as single)
declare sub sfMusic_setVolume(byval music as sfMusic ptr, byval volume as single)
declare sub sfMusic_setPosition(byval music as sfMusic ptr, byval position as sfVector3f)
declare sub sfMusic_setRelativeToListener(byval music as sfMusic ptr, byval relative_ as sfBool)
declare sub sfMusic_setMinDistance(byval music as sfMusic ptr, byval distance as single)
declare sub sfMusic_setAttenuation(byval music as sfMusic ptr, byval attenuation as single)
declare sub sfMusic_setPlayingOffset(byval music as sfMusic ptr, byval timeOffset as sfTime)
declare function sfMusic_getPitch(byval music as const sfMusic ptr) as single
declare function sfMusic_getVolume(byval music as const sfMusic ptr) as single
declare function sfMusic_getPosition(byval music as const sfMusic ptr) as sfVector3f
declare function sfMusic_isRelativeToListener(byval music as const sfMusic ptr) as sfBool
declare function sfMusic_getMinDistance(byval music as const sfMusic ptr) as single
declare function sfMusic_getAttenuation(byval music as const sfMusic ptr) as single

Declare function sfSound_create() as sfSound ptr
declare function sfSound_copy(byval sound as const sfSound ptr) as sfSound ptr
declare sub sfSound_destroy(byval sound as sfSound ptr)
declare sub sfSound_play(byval sound as sfSound ptr)
declare sub sfSound_pause(byval sound as sfSound ptr)
declare sub sfSound_stop(byval sound as sfSound ptr)
declare sub sfSound_setBuffer(byval sound as sfSound ptr, byval buffer as const sfSoundBuffer ptr)
declare function sfSound_getBuffer(byval sound as const sfSound ptr) as const sfSoundBuffer ptr
declare sub sfSound_setLoop(byval sound as sfSound ptr, byval loop_ as sfBool)
declare function sfSound_getLoop(byval sound as const sfSound ptr) as sfBool
declare function sfSound_getStatus(byval sound as const sfSound ptr) as sfSoundStatus
declare sub sfSound_setPitch(byval sound as sfSound ptr, byval pitch as single)
declare sub sfSound_setVolume(byval sound as sfSound ptr, byval volume as single)
declare sub sfSound_setPosition(byval sound as sfSound ptr, byval position as sfVector3f)
declare sub sfSound_setRelativeToListener(byval sound as sfSound ptr, byval relative_ as sfBool)
declare sub sfSound_setMinDistance(byval sound as sfSound ptr, byval distance as single)
declare sub sfSound_setAttenuation(byval sound as sfSound ptr, byval attenuation as single)
declare sub sfSound_setPlayingOffset(byval sound as sfSound ptr, byval timeOffset as sfTime)
declare function sfSound_getPitch(byval sound as const sfSound ptr) as single
declare function sfSound_getVolume(byval sound as const sfSound ptr) as single
declare function sfSound_getPosition(byval sound as const sfSound ptr) as sfVector3f
declare function sfSound_isRelativeToListener(byval sound as const sfSound ptr) as sfBool
declare function sfSound_getMinDistance(byval sound as const sfSound ptr) as single
declare function sfSound_getAttenuation(byval sound as const sfSound ptr) as single
declare function sfSound_getPlayingOffset(byval sound as const sfSound ptr) as sfTime

Declare function sfSoundBuffer_createFromFile(byval filename as const zstring ptr) as sfSoundBuffer ptr
declare function sfSoundBuffer_createFromMemory(byval data_ as const any ptr, byval sizeInBytes as uinteger) as sfSoundBuffer ptr
declare function sfSoundBuffer_createFromStream(byval stream as sfInputStream ptr) as sfSoundBuffer ptr
declare function sfSoundBuffer_createFromSamples(byval samples as const sfInt16 ptr, byval sampleCount as uinteger, byval channelCount as ulong, byval sampleRate as ulong) as sfSoundBuffer ptr
declare function sfSoundBuffer_copy(byval soundBuffer as const sfSoundBuffer ptr) as sfSoundBuffer ptr
declare sub sfSoundBuffer_destroy(byval soundBuffer as sfSoundBuffer ptr)
declare function sfSoundBuffer_saveToFile(byval soundBuffer as const sfSoundBuffer ptr, byval filename as const zstring ptr) as sfBool
declare function sfSoundBuffer_getSamples(byval soundBuffer as const sfSoundBuffer ptr) as const sfInt16 ptr
declare function sfSoundBuffer_getSampleCount(byval soundBuffer as const sfSoundBuffer ptr) as uinteger
declare function sfSoundBuffer_getSampleRate(byval soundBuffer as const sfSoundBuffer ptr) as ulong
declare function sfSoundBuffer_getChannelCount(byval soundBuffer as const sfSoundBuffer ptr) as ulong
declare function sfSoundBuffer_getDuration(byval soundBuffer as const sfSoundBuffer ptr) as sfTime

Declare function sfSoundBufferRecorder_create() as sfSoundBufferRecorder ptr
declare sub sfSoundBufferRecorder_destroy(byval soundBufferRecorder as sfSoundBufferRecorder ptr)
declare sub sfSoundBufferRecorder_start(byval soundBufferRecorder as sfSoundBufferRecorder ptr, byval sampleRate as ulong)
declare sub sfSoundBufferRecorder_stop(byval soundBufferRecorder as sfSoundBufferRecorder ptr)
declare function sfSoundBufferRecorder_getSampleRate(byval soundBufferRecorder as const sfSoundBufferRecorder ptr) as ulong
declare function sfSoundBufferRecorder_getBuffer(byval soundBufferRecorder as const sfSoundBufferRecorder ptr) as const sfSoundBuffer ptr

Type sfSoundRecorderStartCallback as function(byval as any ptr) as sfBool
type sfSoundRecorderProcessCallback as function(byval as const sfInt16 ptr, byval as uinteger, byval as any ptr) as sfBool
type sfSoundRecorderStopCallback as sub(byval as any ptr)

declare function sfSoundRecorder_create(byval onStart as sfSoundRecorderStartCallback, byval onProcess as sfSoundRecorderProcessCallback, byval onStop as sfSoundRecorderStopCallback, byval userData as any ptr) as sfSoundRecorder ptr
declare sub sfSoundRecorder_destroy(byval soundRecorder as sfSoundRecorder ptr)
declare sub sfSoundRecorder_start(byval soundRecorder as sfSoundRecorder ptr, byval sampleRate as ulong)
declare sub sfSoundRecorder_stop(byval soundRecorder as sfSoundRecorder ptr)
declare function sfSoundRecorder_getSampleRate(byval soundRecorder as const sfSoundRecorder ptr) as ulong
declare function sfSoundRecorder_isAvailable() as sfBool



declare function sfContext_create() as sfContext ptr
declare sub sfContext_destroy(byval context as sfContext ptr)
declare sub sfContext_setActive(byval context as sfContext ptr, byval active as sfBool)

Enum
	sfJoystickCount = 8
	sfJoystickButtonCount = 32
	sfJoystickAxisCount = 8
end enum

type sfJoystickAxis as long
enum
	sfJoystickX
	sfJoystickY
	sfJoystickZ
	sfJoystickR
	sfJoystickU
	sfJoystickV
	sfJoystickPovX
	sfJoystickPovY
end enum

declare function sfJoystick_isConnected(byval joystick as ulong) as sfBool
declare function sfJoystick_getButtonCount(byval joystick as ulong) as ulong
declare function sfJoystick_hasAxis(byval joystick as ulong, byval axis as sfJoystickAxis) as sfBool
declare function sfJoystick_isButtonPressed(byval joystick as ulong, byval button as ulong) as sfBool
declare function sfJoystick_getAxisPosition(byval joystick as ulong, byval axis as sfJoystickAxis) as single
declare sub sfJoystick_update()

Type sfKeyCode as long
enum
	sfKeyUnknown = -1
	sfKeyA
	sfKeyB
	sfKeyC
	sfKeyD
	sfKeyE
	sfKeyF
	sfKeyG
	sfKeyH
	sfKeyI
	sfKeyJ
	sfKeyK
	sfKeyL
	sfKeyM
	sfKeyN
	sfKeyO
	sfKeyP
	sfKeyQ
	sfKeyR
	sfKeyS
	sfKeyT
	sfKeyU
	sfKeyV
	sfKeyW
	sfKeyX
	sfKeyY
	sfKeyZ
	sfKeyNum0
	sfKeyNum1
	sfKeyNum2
	sfKeyNum3
	sfKeyNum4
	sfKeyNum5
	sfKeyNum6
	sfKeyNum7
	sfKeyNum8
	sfKeyNum9
	sfKeyEscape
	sfKeyLControl
	sfKeyLShift
	sfKeyLAlt
	sfKeyLSystem
	sfKeyRControl
	sfKeyRShift
	sfKeyRAlt
	sfKeyRSystem
	sfKeyMenu
	sfKeyLBracket
	sfKeyRBracket
	sfKeySemiColon
	sfKeyComma
	sfKeyPeriod
	sfKeyQuote
	sfKeySlash
	sfKeyBackSlash
	sfKeyTilde
	sfKeyEqual
	sfKeyDash
	sfKeySpace
	sfKeyReturn
	sfKeyBack
	sfKeyTab
	sfKeyPageUp
	sfKeyPageDown
	sfKeyEnd
	sfKeyHome
	sfKeyInsert
	sfKeyDelete
	sfKeyAdd
	sfKeySubtract
	sfKeyMultiply
	sfKeyDivide
	sfKeyLeft
	sfKeyRight
	sfKeyUp
	sfKeyDown
	sfKeyNumpad0
	sfKeyNumpad1
	sfKeyNumpad2
	sfKeyNumpad3
	sfKeyNumpad4
	sfKeyNumpad5
	sfKeyNumpad6
	sfKeyNumpad7
	sfKeyNumpad8
	sfKeyNumpad9
	sfKeyF1
	sfKeyF2
	sfKeyF3
	sfKeyF4
	sfKeyF5
	sfKeyF6
	sfKeyF7
	sfKeyF8
	sfKeyF9
	sfKeyF10
	sfKeyF11
	sfKeyF12
	sfKeyF13
	sfKeyF14
	sfKeyF15
	sfKeyPause
	sfKeyCount
end enum

declare function sfKeyboard_isKeyPressed(byval key as sfKeyCode) as sfBool

Type sfMouseButton as long
enum
	sfMouseLeft
	sfMouseRight
	sfMouseMiddle
	sfMouseXButton1
	sfMouseXButton2
	sfMouseButtonCount
end enum

declare function sfMouse_isButtonPressed(byval button as sfMouseButton) as sfBool
declare function sfMouse_getPosition(byval relativeTo as const sfWindow ptr) as sfVector2i
declare sub sfMouse_setPosition(byval position as sfVector2i, byval relativeTo as const sfWindow ptr)

type sfEventType as long
enum
	sfEvtClosed
	sfEvtResized
	sfEvtLostFocus
	sfEvtGainedFocus
	sfEvtTextEntered
	sfEvtKeyPressed
	sfEvtKeyReleased
	sfEvtMouseWheelMoved
	sfEvtMouseButtonPressed
	sfEvtMouseButtonReleased
	sfEvtMouseMoved
	sfEvtMouseEntered
	sfEvtMouseLeft
	sfEvtJoystickButtonPressed
	sfEvtJoystickButtonReleased
	sfEvtJoystickMoved
	sfEvtJoystickConnected
	sfEvtJoystickDisconnected
end enum

type sfKeyEvent
	as sfEventType type
	code as sfKeyCode
	alt as sfBool
	control as sfBool
	shift as sfBool
	system as sfBool
end type

type sfTextEvent
	as sfEventType type
	unicode as sfUint32
end type

type sfMouseMoveEvent
	as sfEventType type
	x as long
	y as long
end type

type sfMouseButtonEvent
	as sfEventType type
	button as sfMouseButton
	x as long
	y as long
end type

type sfMouseWheelEvent
	as sfEventType type
	delta as long
	x as long
	y as long
end type

type sfJoystickMoveEvent
	as sfEventType type
	joystickId as ulong
	axis as sfJoystickAxis
	position as single
end type

type sfJoystickButtonEvent
	as sfEventType type
	joystickId as ulong
	button as ulong
end type

type sfJoystickConnectEvent
	as sfEventType type
	joystickId as ulong
end type

type sfSizeEvent
	as sfEventType type
	width as ulong
	height as ulong
end type

union sfEvent
	as sfEventType type
	size as sfSizeEvent
	key as sfKeyEvent
	text as sfTextEvent
	mouseMove as sfMouseMoveEvent
	mouseButton as sfMouseButtonEvent
	mouseWheel as sfMouseWheelEvent
	joystickMove as sfJoystickMoveEvent
	joystickButton as sfJoystickButtonEvent
	joystickConnect as sfJoystickConnectEvent
end union


type sfVideoMode
	width as ulong
	height as ulong
	bitsPerPixel as ulong
end type

declare function sfVideoMode_getDesktopMode() as sfVideoMode
declare function sfVideoMode_getFullscreenModes(byval Count as uinteger ptr) as const sfVideoMode ptr
declare function sfVideoMode_isValid(byval mode as sfVideoMode) as sfBool


#ifdef __FB_WIN32__
	type sfWindowHandle as HWND__ ptr
#else
	type sfWindowHandle as culong
#endif

enum
	sfNone = 0
	sfTitlebar = 1 shl 0
	sfResize = 1 shl 1
	sfClose = 1 shl 2
	sfFullscreen = 1 shl 3
	sfDefaultStyle = (sfTitlebar or sfResize) or sfClose
end enum

type sfContextSettings
	depthBits as ulong
	stencilBits as ulong
	antialiasingLevel as ulong
	majorVersion as ulong
	minorVersion as ulong
end type

declare function sfWindow_create(byval mode as sfVideoMode, byval title as const zstring ptr, byval style as sfUint32, byval settings as const sfContextSettings ptr) as sfWindow ptr
declare function sfWindow_createUnicode(byval mode as sfVideoMode, byval title as const sfUint32 ptr, byval style as sfUint32, byval settings as const sfContextSettings ptr) as sfWindow ptr
declare function sfWindow_createFromHandle(byval handle as sfWindowHandle, byval settings as const sfContextSettings ptr) as sfWindow ptr
declare sub sfWindow_destroy(byval window_ as sfWindow ptr)
declare sub sfWindow_close(byval window_ as sfWindow ptr)
declare function sfWindow_isOpen(byval window_ as const sfWindow ptr) as sfBool
declare function sfWindow_getSettings(byval window_ as const sfWindow ptr) as sfContextSettings
declare function sfWindow_pollEvent(byval window_ as sfWindow ptr, byval event as sfEvent ptr) as sfBool
declare function sfWindow_waitEvent(byval window_ as sfWindow ptr, byval event as sfEvent ptr) as sfBool
declare function sfWindow_getPosition(byval window_ as const sfWindow ptr) as sfVector2i
declare sub sfWindow_setPosition(byval window_ as sfWindow ptr, byval position as sfVector2i)
declare function sfWindow_getSize(byval window_ as const sfWindow ptr) as sfVector2u
declare sub sfWindow_setSize(byval window_ as sfWindow ptr, byval size as sfVector2u)
declare sub sfWindow_setTitle(byval window_ as sfWindow ptr, byval title as const zstring ptr)
declare sub sfWindow_setUnicodeTitle(byval window_ as sfWindow ptr, byval title as const sfUint32 ptr)
declare sub sfWindow_setIcon(byval window_ as sfWindow ptr, byval width_ as ulong, byval height as ulong, byval pixels as const sfUint8 ptr)
declare sub sfWindow_setVisible(byval window_ as sfWindow ptr, byval visible as sfBool)
declare sub sfWindow_setMouseCursorVisible(byval window_ as sfWindow ptr, byval visible as sfBool)
declare sub sfWindow_setVerticalSyncEnabled(byval window_ as sfWindow ptr, byval enabled as sfBool)
declare sub sfWindow_setKeyRepeatEnabled(byval window_ as sfWindow ptr, byval enabled as sfBool)
declare function sfWindow_setActive(byval window_ as sfWindow ptr, byval active as sfBool) as sfBool
declare sub sfWindow_display(byval window_ as sfWindow ptr)
declare sub sfWindow_setFramerateLimit(byval window_ as sfWindow ptr, byval limit as ulong)
declare sub sfWindow_setJoystickThreshold(byval window_ as sfWindow ptr, byval threshold as single)
declare function sfWindow_getSystemHandle(byval window_ as const sfWindow ptr) as sfWindowHandle


type sfBlendMode as long
enum
	sfBlendAlpha
	sfBlendAdd
	sfBlendMultiply
	sfBlendNone
end enum


type sfColor
	r as sfUint8
	g as sfUint8
	b as sfUint8
	a as sfUint8
end type

Extern     sfBlack as sfColor
Extern     sfWhite as sfColor
Extern     sfRed as sfColor
Extern     sfGreen as sfColor
Extern     sfBlue as sfColor
Extern     sfYellow as sfColor
Extern     sfMagenta as sfColor
Extern     sfCyan as sfColor
Extern     sfTransparent as sfColor

declare function sfColor_fromRGB(byval red as sfUint8, byval green as sfUint8, byval blue as sfUint8) as sfColor
declare function sfColor_fromRGBA(byval red as sfUint8, byval green as sfUint8, byval blue as sfUint8, byval alpha as sfUint8) as sfColor
declare function sfColor_add(byval color1 as sfColor, byval color2 as sfColor) as sfColor
declare function sfColor_modulate(byval color1 as sfColor, byval color2 as sfColor) as sfColor

Type sfFloatRect
	left as single
	top as single
	width as single
	height as single
end type

type sfIntRect
	left as long
	top as long
	width as long
	height as long
end type

declare function sfFloatRect_contains(byval rect as const sfFloatRect ptr, byval x as single, byval y as single) as sfBool
declare function sfIntRect_contains(byval rect as const sfIntRect ptr, byval x as long, byval y as long) as sfBool
declare function sfFloatRect_intersects(byval rect1 as const sfFloatRect ptr, byval rect2 as const sfFloatRect ptr, byval intersection as sfFloatRect ptr) as sfBool
declare function sfIntRect_intersects(byval rect1 as const sfIntRect ptr, byval rect2 as const sfIntRect ptr, byval intersection as sfIntRect ptr) as sfBool

Type sfTransform
	matrix(0 to 8) as single
end type

extern     sfTransform_Identity as sfTransform

declare function sfTransform_fromMatrix(byval a00 as single, byval a01 as single, byval a02 as single, byval a10 as single, byval a11 as single, byval a12 as single, byval a20 as single, byval a21 as single, byval a22 as single) as sfTransform
declare sub sfTransform_getMatrix(byval transform as const sfTransform ptr, byval matrix as single ptr)
declare function sfTransform_getInverse(byval transform as const sfTransform ptr) as sfTransform
declare function sfTransform_transformPoint(byval transform as const sfTransform ptr, byval point_ as sfVector2f) as sfVector2f
declare function sfTransform_transformRect(byval transform as const sfTransform ptr, byval rectangle as sfFloatRect) as sfFloatRect
declare sub sfTransform_combine(byval transform as sfTransform ptr, byval other as const sfTransform ptr)
declare sub sfTransform_translate(byval transform as sfTransform ptr, byval x as single, byval y as single)
declare sub sfTransform_rotate(byval transform as sfTransform ptr, byval angle as single)
declare sub sfTransform_rotateWithCenter(byval transform as sfTransform ptr, byval angle as single, byval centerX as single, byval centerY as single)
declare sub sfTransform_scale(byval transform as sfTransform ptr, byval scaleX as single, byval scaleY as single)
declare sub sfTransform_scaleWithCenter(byval transform as sfTransform ptr, byval scaleX as single, byval scaleY as single, byval centerX as single, byval centerY as single)
declare function sfCircleShape_create() as sfCircleShape ptr
declare function sfCircleShape_copy(byval shape as const sfCircleShape ptr) as sfCircleShape ptr
declare sub sfCircleShape_destroy(byval shape as sfCircleShape ptr)
declare sub sfCircleShape_setPosition(byval shape as sfCircleShape ptr, byval position as sfVector2f)
declare sub sfCircleShape_setRotation(byval shape as sfCircleShape ptr, byval angle as single)
declare sub sfCircleShape_setScale(byval shape as sfCircleShape ptr, byval scale as sfVector2f)
declare sub sfCircleShape_setOrigin(byval shape as sfCircleShape ptr, byval origin as sfVector2f)
declare function sfCircleShape_getPosition(byval shape as const sfCircleShape ptr) as sfVector2f
declare function sfCircleShape_getRotation(byval shape as const sfCircleShape ptr) as single
declare function sfCircleShape_getScale(byval shape as const sfCircleShape ptr) as sfVector2f
declare function sfCircleShape_getOrigin(byval shape as const sfCircleShape ptr) as sfVector2f
declare sub sfCircleShape_move(byval shape as sfCircleShape ptr, byval offset as sfVector2f)
declare sub sfCircleShape_rotate(byval shape as sfCircleShape ptr, byval angle as single)
declare sub sfCircleShape_scale(byval shape as sfCircleShape ptr, byval factors as sfVector2f)
declare function sfCircleShape_getTransform(byval shape as const sfCircleShape ptr) as sfTransform
declare function sfCircleShape_getInverseTransform(byval shape as const sfCircleShape ptr) as sfTransform
declare sub sfCircleShape_setTexture(byval shape as sfCircleShape ptr, byval texture as const sfTexture ptr, byval resetRect as sfBool)
declare sub sfCircleShape_setTextureRect(byval shape as sfCircleShape ptr, byval rect as sfIntRect)
declare sub sfCircleShape_setFillColor(byval shape as sfCircleShape ptr, byval color_ as sfColor)
declare sub sfCircleShape_setOutlineColor(byval shape as sfCircleShape ptr, byval color_ as sfColor)
declare sub sfCircleShape_setOutlineThickness(byval shape as sfCircleShape ptr, byval thickness as single)
declare function sfCircleShape_getTexture(byval shape as const sfCircleShape ptr) as const sfTexture ptr
declare function sfCircleShape_getTextureRect(byval shape as const sfCircleShape ptr) as sfIntRect
declare function sfCircleShape_getFillColor(byval shape as const sfCircleShape ptr) as sfColor
declare function sfCircleShape_getOutlineColor(byval shape as const sfCircleShape ptr) as sfColor
declare function sfCircleShape_getOutlineThickness(byval shape as const sfCircleShape ptr) as single
declare function sfCircleShape_getPointCount(byval shape as const sfCircleShape ptr) as ulong
declare function sfCircleShape_getPoint(byval shape as const sfCircleShape ptr, byval index as ulong) as sfVector2f
declare sub sfCircleShape_setRadius(byval shape as sfCircleShape ptr, byval radius as single)
declare function sfCircleShape_getRadius(byval shape as const sfCircleShape ptr) as single
declare sub sfCircleShape_setPointCount(byval shape as sfCircleShape ptr, byval count as ulong)
declare function sfCircleShape_getLocalBounds(byval shape as const sfCircleShape ptr) as sfFloatRect
declare function sfCircleShape_getGlobalBounds(byval shape as const sfCircleShape ptr) as sfFloatRect

declare function sfConvexShape_create() as sfConvexShape ptr
declare function sfConvexShape_copy(byval shape as const sfConvexShape ptr) as sfConvexShape ptr
declare sub sfConvexShape_destroy(byval shape as sfConvexShape ptr)
declare sub sfConvexShape_setPosition(byval shape as sfConvexShape ptr, byval position as sfVector2f)
declare sub sfConvexShape_setRotation(byval shape as sfConvexShape ptr, byval angle as single)
declare sub sfConvexShape_setScale(byval shape as sfConvexShape ptr, byval scale as sfVector2f)
declare sub sfConvexShape_setOrigin(byval shape as sfConvexShape ptr, byval origin as sfVector2f)
declare function sfConvexShape_getPosition(byval shape as const sfConvexShape ptr) as sfVector2f
declare function sfConvexShape_getRotation(byval shape as const sfConvexShape ptr) as single
declare function sfConvexShape_getScale(byval shape as const sfConvexShape ptr) as sfVector2f
declare function sfConvexShape_getOrigin(byval shape as const sfConvexShape ptr) as sfVector2f
declare sub sfConvexShape_move(byval shape as sfConvexShape ptr, byval offset as sfVector2f)
declare sub sfConvexShape_rotate(byval shape as sfConvexShape ptr, byval angle as single)
declare sub sfConvexShape_scale(byval shape as sfConvexShape ptr, byval factors as sfVector2f)
declare function sfConvexShape_getTransform(byval shape as const sfConvexShape ptr) as sfTransform
declare function sfConvexShape_getInverseTransform(byval shape as const sfConvexShape ptr) as sfTransform
declare sub sfConvexShape_setTexture(byval shape as sfConvexShape ptr, byval texture as const sfTexture ptr, byval resetRect as sfBool)
declare sub sfConvexShape_setTextureRect(byval shape as sfConvexShape ptr, byval rect as sfIntRect)
declare sub sfConvexShape_setFillColor(byval shape as sfConvexShape ptr, byval color_ as sfColor)
declare sub sfConvexShape_setOutlineColor(byval shape as sfConvexShape ptr, byval color_ as sfColor)
declare sub sfConvexShape_setOutlineThickness(byval shape as sfConvexShape ptr, byval thickness as single)
declare function sfConvexShape_getTexture(byval shape as const sfConvexShape ptr) as const sfTexture ptr
declare function sfConvexShape_getTextureRect(byval shape as const sfConvexShape ptr) as sfIntRect
declare function sfConvexShape_getFillColor(byval shape as const sfConvexShape ptr) as sfColor
declare function sfConvexShape_getOutlineColor(byval shape as const sfConvexShape ptr) as sfColor
declare function sfConvexShape_getOutlineThickness(byval shape as const sfConvexShape ptr) as single
declare function sfConvexShape_getPointCount(byval shape as const sfConvexShape ptr) as ulong
declare function sfConvexShape_getPoint(byval shape as const sfConvexShape ptr, byval index as ulong) as sfVector2f
declare sub sfConvexShape_setPointCount(byval shape as sfConvexShape ptr, byval count as ulong)
declare sub sfConvexShape_setPoint(byval shape as sfConvexShape ptr, byval index as ulong, byval point_ as sfVector2f)
declare function sfConvexShape_getLocalBounds(byval shape as const sfConvexShape ptr) as sfFloatRect
declare function sfConvexShape_getGlobalBounds(byval shape as const sfConvexShape ptr) as sfFloatRect

type sfGlyph
	advance as long
	bounds as sfIntRect
	textureRect as sfIntRect
end type

declare function sfFont_createFromFile(byval filename as const zstring ptr) as sfFont ptr
declare function sfFont_createFromMemory(byval data_ as const any ptr, byval sizeInBytes as uinteger) as sfFont ptr
declare function sfFont_createFromStream(byval stream as sfInputStream ptr) as sfFont ptr
declare function sfFont_copy(byval font as const sfFont ptr) as sfFont ptr
declare sub sfFont_destroy(byval font as sfFont ptr)
declare function sfFont_getGlyph(byval font as sfFont ptr, byval codePoint as sfUint32, byval characterSize as ulong, byval bold as sfBool) as sfGlyph
declare function sfFont_getKerning(byval font as sfFont ptr, byval first as sfUint32, byval second as sfUint32, byval characterSize as ulong) as long
declare function sfFont_getLineSpacing(byval font as sfFont ptr, byval characterSize as ulong) as long
declare function sfFont_getTexture(byval font as sfFont ptr, byval characterSize as ulong) as const sfTexture ptr

declare function sfImage_create(byval width_ as ulong, byval height as ulong) as sfImage ptr
declare function sfImage_createFromColor(byval width_ as ulong, byval height as ulong, byval color_ as sfColor) as sfImage ptr
declare function sfImage_createFromPixels(byval width_ as ulong, byval height as ulong, byval pixels as const sfUint8 ptr) as sfImage ptr
declare function sfImage_createFromFile(byval filename as const zstring ptr) as sfImage ptr
declare function sfImage_createFromMemory(byval data_ as const any ptr, byval size as uinteger) as sfImage ptr
declare function sfImage_createFromStream(byval stream as sfInputStream ptr) as sfImage ptr
declare function sfImage_copy(byval image as const sfImage ptr) as sfImage ptr
declare sub sfImage_destroy(byval image as sfImage ptr)
declare function sfImage_saveToFile(byval image as const sfImage ptr, byval filename as const zstring ptr) as sfBool
declare function sfImage_getSize(byval image as const sfImage ptr) as sfVector2u
declare sub sfImage_createMaskFromColor(byval image as sfImage ptr, byval color_ as sfColor, byval alpha as sfUint8)
declare sub sfImage_copyImage(byval image as sfImage ptr, byval source as const sfImage ptr, byval destX as ulong, byval destY as ulong, byval sourceRect as sfIntRect, byval applyAlpha as sfBool)
declare sub sfImage_setPixel(byval image as sfImage ptr, byval x as ulong, byval y as ulong, byval color_ as sfColor)
declare function sfImage_getPixel(byval image as const sfImage ptr, byval x as ulong, byval y as ulong) as sfColor
declare function sfImage_getPixelsPtr(byval image as const sfImage ptr) as const sfUint8 ptr
declare sub sfImage_flipHorizontally(byval image as sfImage ptr)
declare sub sfImage_flipVertically(byval image as sfImage ptr)

type sfPrimitiveType as long
enum
	sfPoints
	sfLines
	sfLinesStrip
	sfTriangles
	sfTrianglesStrip
	sfTrianglesFan
	sfQuads
end enum

declare function sfRectangleShape_create() as sfRectangleShape ptr
declare function sfRectangleShape_copy(byval shape as const sfRectangleShape ptr) as sfRectangleShape ptr
declare sub sfRectangleShape_destroy(byval shape as sfRectangleShape ptr)
declare sub sfRectangleShape_setPosition(byval shape as sfRectangleShape ptr, byval position as sfVector2f)
declare sub sfRectangleShape_setRotation(byval shape as sfRectangleShape ptr, byval angle as single)
declare sub sfRectangleShape_setScale(byval shape as sfRectangleShape ptr, byval scale as sfVector2f)
declare sub sfRectangleShape_setOrigin(byval shape as sfRectangleShape ptr, byval origin as sfVector2f)
declare function sfRectangleShape_getPosition(byval shape as const sfRectangleShape ptr) as sfVector2f
declare function sfRectangleShape_getRotation(byval shape as const sfRectangleShape ptr) as single
declare function sfRectangleShape_getScale(byval shape as const sfRectangleShape ptr) as sfVector2f
declare function sfRectangleShape_getOrigin(byval shape as const sfRectangleShape ptr) as sfVector2f
declare sub sfRectangleShape_move(byval shape as sfRectangleShape ptr, byval offset as sfVector2f)
declare sub sfRectangleShape_rotate(byval shape as sfRectangleShape ptr, byval angle as single)
declare sub sfRectangleShape_scale(byval shape as sfRectangleShape ptr, byval factors as sfVector2f)
declare function sfRectangleShape_getTransform(byval shape as const sfRectangleShape ptr) as sfTransform
declare function sfRectangleShape_getInverseTransform(byval shape as const sfRectangleShape ptr) as sfTransform
declare sub sfRectangleShape_setTexture(byval shape as sfRectangleShape ptr, byval texture as const sfTexture ptr, byval resetRect as sfBool)
declare sub sfRectangleShape_setTextureRect(byval shape as sfRectangleShape ptr, byval rect as sfIntRect)
declare sub sfRectangleShape_setFillColor(byval shape as sfRectangleShape ptr, byval color_ as sfColor)
declare sub sfRectangleShape_setOutlineColor(byval shape as sfRectangleShape ptr, byval color_ as sfColor)
declare sub sfRectangleShape_setOutlineThickness(byval shape as sfRectangleShape ptr, byval thickness as single)
declare function sfRectangleShape_getTexture(byval shape as const sfRectangleShape ptr) as const sfTexture ptr
declare function sfRectangleShape_getTextureRect(byval shape as const sfRectangleShape ptr) as sfIntRect
declare function sfRectangleShape_getFillColor(byval shape as const sfRectangleShape ptr) as sfColor
declare function sfRectangleShape_getOutlineColor(byval shape as const sfRectangleShape ptr) as sfColor
declare function sfRectangleShape_getOutlineThickness(byval shape as const sfRectangleShape ptr) as single
declare function sfRectangleShape_getPointCount(byval shape as const sfRectangleShape ptr) as ulong
declare function sfRectangleShape_getPoint(byval shape as const sfRectangleShape ptr, byval index as ulong) as sfVector2f
declare sub sfRectangleShape_setSize(byval shape as sfRectangleShape ptr, byval size as sfVector2f)
declare function sfRectangleShape_getSize(byval shape as const sfRectangleShape ptr) as sfVector2f
declare function sfRectangleShape_getLocalBounds(byval shape as const sfRectangleShape ptr) as sfFloatRect
declare function sfRectangleShape_getGlobalBounds(byval shape as const sfRectangleShape ptr) as sfFloatRect

type sfRenderStates
	blendMode as sfBlendMode
	transform as sfTransform
	texture as const sfTexture ptr
	shader as const sfShader ptr
end type

type sfVertex
	position as sfVector2f
	color as sfColor
	texCoords as sfVector2f
end type

declare function sfRenderWindow_create(byval mode as sfVideoMode, byval title as const zstring ptr, byval style as sfUint32, byval settings as const sfContextSettings ptr) as sfRenderWindow ptr
declare function sfRenderWindow_createUnicode(byval mode as sfVideoMode, byval title as const sfUint32 ptr, byval style as sfUint32, byval settings as const sfContextSettings ptr) as sfRenderWindow ptr
declare function sfRenderWindow_createFromHandle(byval handle as sfWindowHandle, byval settings as const sfContextSettings ptr) as sfRenderWindow ptr
declare sub sfRenderWindow_destroy(byval renderWindow as sfRenderWindow ptr)
declare sub sfRenderWindow_close(byval renderWindow as sfRenderWindow ptr)
declare function sfRenderWindow_isOpen(byval renderWindow as const sfRenderWindow ptr) as sfBool
declare function sfRenderWindow_getSettings(byval renderWindow as const sfRenderWindow ptr) as sfContextSettings
declare function sfRenderWindow_pollEvent(byval renderWindow as sfRenderWindow ptr, byval event as sfEvent ptr) as sfBool
declare function sfRenderWindow_waitEvent(byval renderWindow as sfRenderWindow ptr, byval event as sfEvent ptr) as sfBool
declare function sfRenderWindow_getPosition(byval renderWindow as const sfRenderWindow ptr) as sfVector2i
declare sub sfRenderWindow_setPosition(byval renderWindow as sfRenderWindow ptr, byval position as sfVector2i)
declare function sfRenderWindow_getSize(byval renderWindow as const sfRenderWindow ptr) as sfVector2u
declare sub sfRenderWindow_setSize(byval renderWindow as sfRenderWindow ptr, byval size as sfVector2u)
declare sub sfRenderWindow_setTitle(byval renderWindow as sfRenderWindow ptr, byval title as const zstring ptr)
declare sub sfRenderWindow_setUnicodeTitle(byval renderWindow as sfRenderWindow ptr, byval title as const sfUint32 ptr)
declare sub sfRenderWindow_setIcon(byval renderWindow as sfRenderWindow ptr, byval width_ as ulong, byval height as ulong, byval pixels as const sfUint8 ptr)
declare sub sfRenderWindow_setVisible(byval renderWindow as sfRenderWindow ptr, byval visible as sfBool)
declare sub sfRenderWindow_setMouseCursorVisible(byval renderWindow as sfRenderWindow ptr, byval show as sfBool)
declare sub sfRenderWindow_setVerticalSyncEnabled(byval renderWindow as sfRenderWindow ptr, byval enabled as sfBool)
declare sub sfRenderWindow_setKeyRepeatEnabled(byval renderWindow as sfRenderWindow ptr, byval enabled as sfBool)
declare function sfRenderWindow_setActive(byval renderWindow as sfRenderWindow ptr, byval active as sfBool) as sfBool
declare sub sfRenderWindow_display(byval renderWindow as sfRenderWindow ptr)
declare sub sfRenderWindow_setFramerateLimit(byval renderWindow as sfRenderWindow ptr, byval limit as ulong)
declare sub sfRenderWindow_setJoystickThreshold(byval renderWindow as sfRenderWindow ptr, byval threshold as single)
declare function sfRenderWindow_getSystemHandle(byval renderWindow as const sfRenderWindow ptr) as sfWindowHandle
declare sub sfRenderWindow_clear(byval renderWindow as sfRenderWindow ptr, byval color_ as sfColor)
declare sub sfRenderWindow_setView(byval renderWindow as sfRenderWindow ptr, byval view_ as const sfView ptr)
declare function sfRenderWindow_getView(byval renderWindow as const sfRenderWindow ptr) as const sfView ptr
declare function sfRenderWindow_getDefaultView(byval renderWindow as const sfRenderWindow ptr) as const sfView ptr
declare function sfRenderWindow_getViewport(byval renderWindow as const sfRenderWindow ptr, byval view_ as const sfView ptr) as sfIntRect
declare function sfRenderWindow_mapPixelToCoords(byval renderWindow as const sfRenderWindow ptr, byval point_ as sfVector2i, byval view_ as const sfView ptr) as sfVector2f
declare function sfRenderWindow_mapCoordsToPixel(byval renderWindow as const sfRenderWindow ptr, byval point_ as sfVector2f, byval view_ as const sfView ptr) as sfVector2i
declare sub sfRenderWindow_drawSprite(byval renderWindow as sfRenderWindow ptr, byval object_ as const sfSprite ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderWindow_drawText(byval renderWindow as sfRenderWindow ptr, byval object_ as const sfText ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderWindow_drawShape(byval renderWindow as sfRenderWindow ptr, byval object_ as const sfShape ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderWindow_drawCircleShape(byval renderWindow as sfRenderWindow ptr, byval object_ as const sfCircleShape ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderWindow_drawConvexShape(byval renderWindow as sfRenderWindow ptr, byval object_ as const sfConvexShape ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderWindow_drawRectangleShape(byval renderWindow as sfRenderWindow ptr, byval object_ as const sfRectangleShape ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderWindow_drawVertexArray(byval renderWindow as sfRenderWindow ptr, byval object_ as const sfVertexArray ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderWindow_drawPrimitives(byval renderWindow as sfRenderWindow ptr, byval vertices as const sfVertex ptr, byval vertexCount as ulong, byval type_ as sfPrimitiveType, byval states as const sfRenderStates ptr)
declare sub sfRenderWindow_pushGLStates(byval renderWindow as sfRenderWindow ptr)
declare sub sfRenderWindow_popGLStates(byval renderWindow as sfRenderWindow ptr)
declare sub sfRenderWindow_resetGLStates(byval renderWindow as sfRenderWindow ptr)
declare function sfRenderWindow_capture(byval renderWindow as const sfRenderWindow ptr) as sfImage ptr
declare function sfMouse_getPositionRenderWindow(byval relativeTo as const sfRenderWindow ptr) as sfVector2i
declare sub sfMouse_setPositionRenderWindow(byval position as sfVector2i, byval relativeTo as const sfRenderWindow ptr)

declare function sfRenderTexture_create(byval width_ as ulong, byval height as ulong, byval depthBuffer as sfBool) as sfRenderTexture ptr
declare sub sfRenderTexture_destroy(byval renderTexture as sfRenderTexture ptr)
declare function sfRenderTexture_getSize(byval renderTexture as const sfRenderTexture ptr) as sfVector2u
declare function sfRenderTexture_setActive(byval renderTexture as sfRenderTexture ptr, byval active as sfBool) as sfBool
declare sub sfRenderTexture_display(byval renderTexture as sfRenderTexture ptr)
declare sub sfRenderTexture_clear(byval renderTexture as sfRenderTexture ptr, byval color_ as sfColor)
declare sub sfRenderTexture_setView(byval renderTexture as sfRenderTexture ptr, byval view_ as const sfView ptr)
declare function sfRenderTexture_getView(byval renderTexture as const sfRenderTexture ptr) as const sfView ptr
declare function sfRenderTexture_getDefaultView(byval renderTexture as const sfRenderTexture ptr) as const sfView ptr
declare function sfRenderTexture_getViewport(byval renderTexture as const sfRenderTexture ptr, byval view_ as const sfView ptr) as sfIntRect
declare function sfRenderTexture_mapPixelToCoords(byval renderTexture as const sfRenderTexture ptr, byval point_ as sfVector2i, byval view_ as const sfView ptr) as sfVector2f
declare function sfRenderTexture_mapCoordsToPixel(byval renderTexture as const sfRenderTexture ptr, byval point_ as sfVector2f, byval view_ as const sfView ptr) as sfVector2i
declare sub sfRenderTexture_drawSprite(byval renderTexture as sfRenderTexture ptr, byval object_ as const sfSprite ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderTexture_drawText(byval renderTexture as sfRenderTexture ptr, byval object_ as const sfText ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderTexture_drawShape(byval renderTexture as sfRenderTexture ptr, byval object_ as const sfShape ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderTexture_drawCircleShape(byval renderTexture as sfRenderTexture ptr, byval object_ as const sfCircleShape ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderTexture_drawConvexShape(byval renderTexture as sfRenderTexture ptr, byval object_ as const sfConvexShape ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderTexture_drawRectangleShape(byval renderTexture as sfRenderTexture ptr, byval object_ as const sfRectangleShape ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderTexture_drawVertexArray(byval renderTexture as sfRenderTexture ptr, byval object_ as const sfVertexArray ptr, byval states as const sfRenderStates ptr)
declare sub sfRenderTexture_drawPrimitives(byval renderTexture as sfRenderTexture ptr, byval vertices as const sfVertex ptr, byval vertexCount as ulong, byval type_ as sfPrimitiveType, byval states as const sfRenderStates ptr)
declare sub sfRenderTexture_pushGLStates(byval renderTexture as sfRenderTexture ptr)
declare sub sfRenderTexture_popGLStates(byval renderTexture as sfRenderTexture ptr)
declare sub sfRenderTexture_resetGLStates(byval renderTexture as sfRenderTexture ptr)
declare function sfRenderTexture_getTexture(byval renderTexture as const sfRenderTexture ptr) as const sfTexture ptr
declare sub sfRenderTexture_setSmooth(byval renderTexture as sfRenderTexture ptr, byval smooth as sfBool)
declare function sfRenderTexture_isSmooth(byval renderTexture as const sfRenderTexture ptr) as sfBool
declare sub sfRenderTexture_setRepeated(byval renderTexture as sfRenderTexture ptr, byval repeated as sfBool)
declare function sfRenderTexture_isRepeated(byval renderTexture as const sfRenderTexture ptr) as sfBool

declare function sfShader_createFromFile(byval vertexShaderFilename as const zstring ptr, byval fragmentShaderFilename as const zstring ptr) as sfShader ptr
declare function sfShader_createFromMemory(byval vertexShader as const zstring ptr, byval fragmentShader as const zstring ptr) as sfShader ptr
declare function sfShader_createFromStream(byval vertexShaderStream as sfInputStream ptr, byval fragmentShaderStream as sfInputStream ptr) as sfShader ptr
declare sub sfShader_destroy(byval shader as sfShader ptr)
declare sub sfShader_setFloatParameter(byval shader as sfShader ptr, byval name_ as const zstring ptr, byval x as single)
declare sub sfShader_setFloat2Parameter(byval shader as sfShader ptr, byval name_ as const zstring ptr, byval x as single, byval y as single)
declare sub sfShader_setFloat3Parameter(byval shader as sfShader ptr, byval name_ as const zstring ptr, byval x as single, byval y as single, byval z as single)
declare sub sfShader_setFloat4Parameter(byval shader as sfShader ptr, byval name_ as const zstring ptr, byval x as single, byval y as single, byval z as single, byval w as single)
declare sub sfShader_setVector2Parameter(byval shader as sfShader ptr, byval name_ as const zstring ptr, byval vector as sfVector2f)
declare sub sfShader_setVector3Parameter(byval shader as sfShader ptr, byval name_ as const zstring ptr, byval vector as sfVector3f)
declare sub sfShader_setColorParameter(byval shader as sfShader ptr, byval name_ as const zstring ptr, byval color_ as sfColor)
declare sub sfShader_setTransformParameter(byval shader as sfShader ptr, byval name_ as const zstring ptr, byval transform as sfTransform)
declare sub sfShader_setTextureParameter(byval shader as sfShader ptr, byval name_ as const zstring ptr, byval texture as const sfTexture ptr)
declare sub sfShader_setCurrentTextureParameter(byval shader as sfShader ptr, byval name_ as const zstring ptr)
declare sub sfShader_bind(byval shader as const sfShader ptr)
declare function sfShader_isAvailable() as sfBool

type sfShapeGetPointCountCallback as function(byval as any ptr) as ulong
type sfShapeGetPointCallback as function(byval as ulong, byval as any ptr) as sfVector2f

declare function sfShape_create(byval getPointCount as sfShapeGetPointCountCallback, byval getPoint as sfShapeGetPointCallback, byval userData as any ptr) as sfShape ptr
declare sub sfShape_destroy(byval shape as sfShape ptr)
declare sub sfShape_setPosition(byval shape as sfShape ptr, byval position as sfVector2f)
declare sub sfShape_setRotation(byval shape as sfShape ptr, byval angle as single)
declare sub sfShape_setScale(byval shape as sfShape ptr, byval scale as sfVector2f)
declare sub sfShape_setOrigin(byval shape as sfShape ptr, byval origin as sfVector2f)
declare function sfShape_getPosition(byval shape as const sfShape ptr) as sfVector2f
declare function sfShape_getRotation(byval shape as const sfShape ptr) as single
declare function sfShape_getScale(byval shape as const sfShape ptr) as sfVector2f
declare function sfShape_getOrigin(byval shape as const sfShape ptr) as sfVector2f
declare sub sfShape_move(byval shape as sfShape ptr, byval offset as sfVector2f)
declare sub sfShape_rotate(byval shape as sfShape ptr, byval angle as single)
declare sub sfShape_scale(byval shape as sfShape ptr, byval factors as sfVector2f)
declare function sfShape_getTransform(byval shape as const sfShape ptr) as sfTransform
declare function sfShape_getInverseTransform(byval shape as const sfShape ptr) as sfTransform
declare sub sfShape_setTexture(byval shape as sfShape ptr, byval texture as const sfTexture ptr, byval resetRect as sfBool)
declare sub sfShape_setTextureRect(byval shape as sfShape ptr, byval rect as sfIntRect)
declare sub sfShape_setFillColor(byval shape as sfShape ptr, byval color_ as sfColor)
declare sub sfShape_setOutlineColor(byval shape as sfShape ptr, byval color_ as sfColor)
declare sub sfShape_setOutlineThickness(byval shape as sfShape ptr, byval thickness as single)
declare function sfShape_getTexture(byval shape as const sfShape ptr) as const sfTexture ptr
declare function sfShape_getTextureRect(byval shape as const sfShape ptr) as sfIntRect
declare function sfShape_getFillColor(byval shape as const sfShape ptr) as sfColor
declare function sfShape_getOutlineColor(byval shape as const sfShape ptr) as sfColor
declare function sfShape_getOutlineThickness(byval shape as const sfShape ptr) as single
declare function sfShape_getPointCount(byval shape as const sfShape ptr) as ulong
declare function sfShape_getPoint(byval shape as const sfShape ptr, byval index as ulong) as sfVector2f
declare function sfShape_getLocalBounds(byval shape as const sfShape ptr) as sfFloatRect
declare function sfShape_getGlobalBounds(byval shape as const sfShape ptr) as sfFloatRect
declare sub sfShape_update(byval shape as sfShape ptr)

declare function sfSprite_create() as sfSprite ptr
declare function sfSprite_copy(byval sprite as const sfSprite ptr) as sfSprite ptr
declare sub sfSprite_destroy(byval sprite as sfSprite ptr)
declare sub sfSprite_setPosition(byval sprite as sfSprite ptr, byval position as sfVector2f)
declare sub sfSprite_setRotation(byval sprite as sfSprite ptr, byval angle as single)
declare sub sfSprite_setScale(byval sprite as sfSprite ptr, byval scale as sfVector2f)
declare sub sfSprite_setOrigin(byval sprite as sfSprite ptr, byval origin as sfVector2f)
declare function sfSprite_getPosition(byval sprite as const sfSprite ptr) as sfVector2f
declare function sfSprite_getRotation(byval sprite as const sfSprite ptr) as single
declare function sfSprite_getScale(byval sprite as const sfSprite ptr) as sfVector2f
declare function sfSprite_getOrigin(byval sprite as const sfSprite ptr) as sfVector2f
declare sub sfSprite_move(byval sprite as sfSprite ptr, byval offset as sfVector2f)
declare sub sfSprite_rotate(byval sprite as sfSprite ptr, byval angle as single)
declare sub sfSprite_scale(byval sprite as sfSprite ptr, byval factors as sfVector2f)
declare function sfSprite_getTransform(byval sprite as const sfSprite ptr) as sfTransform
declare function sfSprite_getInverseTransform(byval sprite as const sfSprite ptr) as sfTransform
declare sub sfSprite_setTexture(byval sprite as sfSprite ptr, byval texture as const sfTexture ptr, byval resetRect as sfBool)
declare sub sfSprite_setTextureRect(byval sprite as sfSprite ptr, byval rectangle as sfIntRect)
declare sub sfSprite_setColor(byval sprite as sfSprite ptr, byval color_ as sfColor)
declare function sfSprite_getTexture(byval sprite as const sfSprite ptr) as const sfTexture ptr
declare function sfSprite_getTextureRect(byval sprite as const sfSprite ptr) as sfIntRect
declare function sfSprite_getColor(byval sprite as const sfSprite ptr) as sfColor
declare function sfSprite_getLocalBounds(byval sprite as const sfSprite ptr) as sfFloatRect
declare function sfSprite_getGlobalBounds(byval sprite as const sfSprite ptr) as sfFloatRect

type sfTextStyle as long
enum
	sfTextRegular = 0
	sfTextBold = 1 shl 0
	sfTextItalic = 1 shl 1
	sfTextUnderlined = 1 shl 2
end enum

declare function sfText_create() as sfText ptr
declare function sfText_copy(byval text as const sfText ptr) as sfText ptr
declare sub sfText_destroy(byval text as sfText ptr)
declare sub sfText_setPosition(byval text as sfText ptr, byval position as sfVector2f)
declare sub sfText_setRotation(byval text as sfText ptr, byval angle as single)
declare sub sfText_setScale(byval text as sfText ptr, byval scale as sfVector2f)
declare sub sfText_setOrigin(byval text as sfText ptr, byval origin as sfVector2f)
declare function sfText_getPosition(byval text as const sfText ptr) as sfVector2f
declare function sfText_getRotation(byval text as const sfText ptr) as single
declare function sfText_getScale(byval text as const sfText ptr) as sfVector2f
declare function sfText_getOrigin(byval text as const sfText ptr) as sfVector2f
declare sub sfText_move(byval text as sfText ptr, byval offset as sfVector2f)
declare sub sfText_rotate(byval text as sfText ptr, byval angle as single)
declare sub sfText_scale(byval text as sfText ptr, byval factors as sfVector2f)
declare function sfText_getTransform(byval text as const sfText ptr) as sfTransform
declare function sfText_getInverseTransform(byval text as const sfText ptr) as sfTransform
declare sub sfText_setString(byval text as sfText Ptr, byval string_ as const zstring ptr)
declare sub sfText_setUnicodeString(byval text as sfText ptr, byval string_ as const sfUint32 ptr)
declare sub sfText_setFont(byval text as sfText ptr, byval font as const sfFont ptr)
declare sub sfText_setCharacterSize(byval text as sfText ptr, byval size as ulong)
declare sub sfText_setStyle(byval text as sfText ptr, byval style as sfUint32)
declare sub sfText_setColor(byval text as sfText ptr, byval color_ as sfColor)
declare function sfText_getString(byval text as const sfText ptr) as const zstring ptr
declare function sfText_getUnicodeString(byval text as const sfText ptr) as const sfUint32 ptr
declare function sfText_getFont(byval text as const sfText ptr) as const sfFont ptr
declare function sfText_getCharacterSize(byval text as const sfText ptr) as ulong
declare function sfText_getStyle(byval text as const sfText ptr) as sfUint32
declare function sfText_getColor(byval text as const sfText ptr) as sfColor
declare function sfText_findCharacterPos(byval text as const sfText ptr, byval index as uinteger) as sfVector2f
declare function sfText_getLocalBounds(byval text as const sfText ptr) as sfFloatRect
declare function sfText_getGlobalBounds(byval text as const sfText ptr) as sfFloatRect

declare function sfTexture_create(byval width_ as ulong, byval height as ulong) as sfTexture ptr
declare function sfTexture_createFromFile(byval filename as const zstring ptr, byval area as const sfIntRect ptr) as sfTexture ptr
declare function sfTexture_createFromMemory(byval data_ as const any ptr, byval sizeInBytes as uinteger, byval area as const sfIntRect ptr) as sfTexture ptr
declare function sfTexture_createFromStream(byval stream as sfInputStream ptr, byval area as const sfIntRect ptr) as sfTexture ptr
declare function sfTexture_createFromImage(byval image as const sfImage ptr, byval area as const sfIntRect ptr) as sfTexture ptr
declare function sfTexture_copy(byval texture as const sfTexture ptr) as sfTexture ptr
declare sub sfTexture_destroy(byval texture as sfTexture ptr)
declare function sfTexture_getSize(byval texture as const sfTexture ptr) as sfVector2u
declare function sfTexture_copyToImage(byval texture as const sfTexture ptr) as sfImage ptr
declare sub sfTexture_updateFromPixels(byval texture as sfTexture ptr, byval pixels as const sfUint8 ptr, byval width_ as ulong, byval height as ulong, byval x as ulong, byval y as ulong)
declare sub sfTexture_updateFromImage(byval texture as sfTexture ptr, byval image as const sfImage ptr, byval x as ulong, byval y as ulong)
declare sub sfTexture_updateFromWindow(byval texture as sfTexture ptr, byval window_ as const sfWindow ptr, byval x as ulong, byval y as ulong)
declare sub sfTexture_updateFromRenderWindow(byval texture as sfTexture ptr, byval renderWindow as const sfRenderWindow ptr, byval x as ulong, byval y as ulong)
declare sub sfTexture_setSmooth(byval texture as sfTexture ptr, byval smooth as sfBool)
declare function sfTexture_isSmooth(byval texture as const sfTexture ptr) as sfBool
declare sub sfTexture_setRepeated(byval texture as sfTexture ptr, byval repeated as sfBool)
declare function sfTexture_isRepeated(byval texture as const sfTexture ptr) as sfBool
declare sub sfTexture_bind(byval texture as const sfTexture ptr)
declare function sfTexture_getMaximumSize() as ulong

declare function sfTransformable_create() as sfTransformable ptr
declare function sfTransformable_copy(byval transformable as const sfTransformable ptr) as sfTransformable ptr
declare sub sfTransformable_destroy(byval transformable as sfTransformable ptr)
declare sub sfTransformable_setPosition(byval transformable as sfTransformable ptr, byval position as sfVector2f)
declare sub sfTransformable_setRotation(byval transformable as sfTransformable ptr, byval angle as single)
declare sub sfTransformable_setScale(byval transformable as sfTransformable ptr, byval scale as sfVector2f)
declare sub sfTransformable_setOrigin(byval transformable as sfTransformable ptr, byval origin as sfVector2f)
declare function sfTransformable_getPosition(byval transformable as const sfTransformable ptr) as sfVector2f
declare function sfTransformable_getRotation(byval transformable as const sfTransformable ptr) as single
declare function sfTransformable_getScale(byval transformable as const sfTransformable ptr) as sfVector2f
declare function sfTransformable_getOrigin(byval transformable as const sfTransformable ptr) as sfVector2f
declare sub sfTransformable_move(byval transformable as sfTransformable ptr, byval offset as sfVector2f)
declare sub sfTransformable_rotate(byval transformable as sfTransformable ptr, byval angle as single)
declare sub sfTransformable_scale(byval transformable as sfTransformable ptr, byval factors as sfVector2f)
declare function sfTransformable_getTransform(byval transformable as const sfTransformable ptr) as sfTransform
declare function sfTransformable_getInverseTransform(byval transformable as const sfTransformable ptr) as sfTransform

declare function sfVertexArray_create() as sfVertexArray ptr
declare function sfVertexArray_copy(byval vertexArray as const sfVertexArray ptr) as sfVertexArray ptr
declare sub sfVertexArray_destroy(byval vertexArray as sfVertexArray ptr)
declare function sfVertexArray_getVertexCount(byval vertexArray as const sfVertexArray ptr) as ulong
declare function sfVertexArray_getVertex(byval vertexArray as sfVertexArray ptr, byval index as ulong) as sfVertex ptr
declare sub sfVertexArray_clear(byval vertexArray as sfVertexArray ptr)
declare sub sfVertexArray_resize(byval vertexArray as sfVertexArray ptr, byval vertexCount as ulong)
declare sub sfVertexArray_append(byval vertexArray as sfVertexArray ptr, byval vertex as sfVertex)
declare sub sfVertexArray_setPrimitiveType(byval vertexArray as sfVertexArray ptr, byval type_ as sfPrimitiveType)
declare function sfVertexArray_getPrimitiveType(byval vertexArray as sfVertexArray ptr) as sfPrimitiveType
declare function sfVertexArray_getBounds(byval vertexArray as sfVertexArray ptr) as sfFloatRect

declare function sfView_create() as sfView ptr
declare function sfView_createFromRect(byval rectangle as sfFloatRect) as sfView ptr
declare function sfView_copy(byval view_ as const sfView ptr) as sfView ptr
declare sub sfView_destroy(byval view_ as sfView ptr)
declare sub sfView_setCenter(byval view_ as sfView ptr, byval center as sfVector2f)
declare sub sfView_setSize(byval view_ as sfView ptr, byval size as sfVector2f)
declare sub sfView_setRotation(byval view_ as sfView ptr, byval angle as single)
declare sub sfView_setViewport(byval view_ as sfView ptr, byval viewport as sfFloatRect)
declare sub sfView_reset(byval view_ as sfView ptr, byval rectangle as sfFloatRect)
declare function sfView_getCenter(byval view_ as const sfView ptr) as sfVector2f
declare function sfView_getSize(byval view_ as const sfView ptr) as sfVector2f
declare function sfView_getRotation(byval view_ as const sfView ptr) as single
declare function sfView_getViewport(byval view_ as const sfView ptr) as sfFloatRect
declare sub sfView_move(byval view_ as sfView ptr, byval offset as sfVector2f)
declare sub sfView_rotate(byval view_ as sfView ptr, byval angle as single)
declare sub sfView_zoom(byval view_ as sfView ptr, byval factor as single)

type sfIpAddress
	address as zstring * 16
end type

extern     sfIpAddress_None as sfIpAddress
Extern     sfIpAddress_LocalHost as sfIpAddress
Extern     sfIpAddress_Broadcast as sfIpAddress

declare function sfIpAddress_fromString(byval address as const zstring ptr) as sfIpAddress
declare function sfIpAddress_fromBytes(byval byte0 as sfUint8, byval byte1 as sfUint8, byval byte2 as sfUint8, byval byte3 as sfUint8) as sfIpAddress
declare function sfIpAddress_fromInteger(byval address as sfUint32) as sfIpAddress
declare sub sfIpAddress_toString(byval address as sfIpAddress, byval string_ as zstring ptr)
declare function sfIpAddress_toInteger(byval address as sfIpAddress) as sfUint32
declare function sfIpAddress_getLocalAddress() as sfIpAddress
declare function sfIpAddress_getPublicAddress(byval timeout as sfTime) as sfIpAddress

type sfFtpTransferMode as long
enum
	sfFtpBinary
	sfFtpAscii
	sfFtpEbcdic
end enum

type sfFtpStatus as long
enum
	sfFtpRestartMarkerReply = 110
	sfFtpServiceReadySoon = 120
	sfFtpDataConnectionAlreadyOpened = 125
	sfFtpOpeningDataConnection = 150
	sfFtpOk = 200
	sfFtpPointlessCommand = 202
	sfFtpSystemStatus = 211
	sfFtpDirectoryStatus = 212
	sfFtpFileStatus = 213
	sfFtpHelpMessage = 214
	sfFtpSystemType = 215
	sfFtpServiceReady = 220
	sfFtpClosingConnection = 221
	sfFtpDataConnectionOpened = 225
	sfFtpClosingDataConnection = 226
	sfFtpEnteringPassiveMode = 227
	sfFtpLoggedIn = 230
	sfFtpFileActionOk = 250
	sfFtpDirectoryOk = 257
	sfFtpNeedPassword = 331
	sfFtpNeedAccountToLogIn = 332
	sfFtpNeedInformation = 350
	sfFtpServiceUnavailable = 421
	sfFtpDataConnectionUnavailable = 425
	sfFtpTransferAborted = 426
	sfFtpFileActionAborted = 450
	sfFtpLocalError = 451
	sfFtpInsufficientStorageSpace = 452
	sfFtpCommandUnknown = 500
	sfFtpParametersUnknown = 501
	sfFtpCommandNotImplemented = 502
	sfFtpBadCommandSequence = 503
	sfFtpParameterNotImplemented = 504
	sfFtpNotLoggedIn = 530
	sfFtpNeedAccountToStore = 532
	sfFtpFileUnavailable = 550
	sfFtpPageTypeUnknown = 551
	sfFtpNotEnoughMemory = 552
	sfFtpFilenameNotAllowed = 553
	sfFtpInvalidResponse = 1000
	sfFtpConnectionFailed = 1001
	sfFtpConnectionClosed = 1002
	sfFtpInvalidFile = 1003
end enum

declare sub sfFtpListingResponse_destroy(byval ftpListingResponse as sfFtpListingResponse ptr)
declare function sfFtpListingResponse_isOk(byval ftpListingResponse as const sfFtpListingResponse ptr) as sfBool
declare function sfFtpListingResponse_getStatus(byval ftpListingResponse as const sfFtpListingResponse ptr) as sfFtpStatus
declare function sfFtpListingResponse_getMessage(byval ftpListingResponse as const sfFtpListingResponse ptr) as const zstring ptr
declare function sfFtpListingResponse_getCount(byval ftpListingResponse as const sfFtpListingResponse ptr) as uinteger
declare function sfFtpListingResponse_getName(byval ftpListingResponse as const sfFtpListingResponse ptr, byval index as uinteger) as const zstring ptr
declare sub sfFtpDirectoryResponse_destroy(byval ftpDirectoryResponse as sfFtpDirectoryResponse ptr)
declare function sfFtpDirectoryResponse_isOk(byval ftpDirectoryResponse as const sfFtpDirectoryResponse ptr) as sfBool
declare function sfFtpDirectoryResponse_getStatus(byval ftpDirectoryResponse as const sfFtpDirectoryResponse ptr) as sfFtpStatus
declare function sfFtpDirectoryResponse_getMessage(byval ftpDirectoryResponse as const sfFtpDirectoryResponse ptr) as const zstring ptr
declare function sfFtpDirectoryResponse_getDirectory(byval ftpDirectoryResponse as const sfFtpDirectoryResponse ptr) as const zstring ptr
declare sub sfFtpResponse_destroy(byval ftpResponse as sfFtpResponse ptr)
declare function sfFtpResponse_isOk(byval ftpResponse as const sfFtpResponse ptr) as sfBool
declare function sfFtpResponse_getStatus(byval ftpResponse as const sfFtpResponse ptr) as sfFtpStatus
declare function sfFtpResponse_getMessage(byval ftpResponse as const sfFtpResponse ptr) as const zstring ptr
declare function sfFtp_create() as sfFtp ptr
declare sub sfFtp_destroy(byval ftp as sfFtp ptr)
declare function sfFtp_connect(byval ftp as sfFtp ptr, byval server as sfIpAddress, byval port as ushort, byval timeout as sfTime) as sfFtpResponse ptr
declare function sfFtp_loginAnonymous(byval ftp as sfFtp ptr) as sfFtpResponse ptr
declare function sfFtp_login(byval ftp as sfFtp ptr, byval userName as const zstring ptr, byval password as const zstring ptr) as sfFtpResponse ptr
declare function sfFtp_disconnect(byval ftp as sfFtp ptr) as sfFtpResponse ptr
declare function sfFtp_keepAlive(byval ftp as sfFtp ptr) as sfFtpResponse ptr
declare function sfFtp_getWorkingDirectory(byval ftp as sfFtp ptr) as sfFtpDirectoryResponse ptr
declare function sfFtp_getDirectoryListing(byval ftp as sfFtp ptr, byval directory as const zstring ptr) as sfFtpListingResponse ptr
declare function sfFtp_changeDirectory(byval ftp as sfFtp ptr, byval directory as const zstring ptr) as sfFtpResponse ptr
declare function sfFtp_parentDirectory(byval ftp as sfFtp ptr) as sfFtpResponse ptr
declare function sfFtp_createDirectory(byval ftp as sfFtp ptr, byval name_ as const zstring ptr) as sfFtpResponse ptr
declare function sfFtp_deleteDirectory(byval ftp as sfFtp ptr, byval name_ as const zstring ptr) as sfFtpResponse ptr
declare function sfFtp_renameFile(byval ftp as sfFtp ptr, byval file as const zstring ptr, byval newName as const zstring ptr) as sfFtpResponse ptr
declare function sfFtp_deleteFile(byval ftp as sfFtp ptr, byval name_ as const zstring ptr) as sfFtpResponse ptr
declare function sfFtp_download(byval ftp as sfFtp ptr, byval distantFile as const zstring ptr, byval destPath as const zstring ptr, byval mode as sfFtpTransferMode) as sfFtpResponse ptr
declare function sfFtp_upload(byval ftp as sfFtp ptr, byval localFile as const zstring ptr, byval destPath as const zstring ptr, byval mode as sfFtpTransferMode) as sfFtpResponse ptr

type sfHttpMethod as long
enum
	sfHttpGet
	sfHttpPost
	sfHttpHead
end enum

type sfHttpStatus as long
enum
	sfHttpOk = 200
	sfHttpCreated = 201
	sfHttpAccepted = 202
	sfHttpNoContent = 204
	sfHttpResetContent = 205
	sfHttpPartialContent = 206
	sfHttpMultipleChoices = 300
	sfHttpMovedPermanently = 301
	sfHttpMovedTemporarily = 302
	sfHttpNotModified = 304
	sfHttpBadRequest = 400
	sfHttpUnauthorized = 401
	sfHttpForbidden = 403
	sfHttpNotFound = 404
	sfHttpRangeNotSatisfiable = 407
	sfHttpInternalServerError = 500
	sfHttpNotImplemented = 501
	sfHttpBadGateway = 502
	sfHttpServiceNotAvailable = 503
	sfHttpGatewayTimeout = 504
	sfHttpVersionNotSupported = 505
	sfHttpInvalidResponse = 1000
	sfHttpConnectionFailed = 1001
end enum

declare function sfHttpRequest_create() as sfHttpRequest ptr
declare sub sfHttpRequest_destroy(byval httpRequest as sfHttpRequest ptr)
declare sub sfHttpRequest_setField(byval httpRequest as sfHttpRequest ptr, byval field_ as const zstring ptr, byval value as const zstring ptr)
declare sub sfHttpRequest_setMethod(byval httpRequest as sfHttpRequest ptr, byval method as sfHttpMethod)
declare sub sfHttpRequest_setUri(byval httpRequest as sfHttpRequest ptr, byval uri as const zstring ptr)
declare sub sfHttpRequest_setHttpVersion(byval httpRequest as sfHttpRequest ptr, byval major as ulong, byval minor as ulong)
declare sub sfHttpRequest_setBody(byval httpRequest as sfHttpRequest ptr, byval body as const zstring ptr)
declare sub sfHttpResponse_destroy(byval httpResponse as sfHttpResponse ptr)
declare function sfHttpResponse_getField(byval httpResponse as const sfHttpResponse ptr, byval field_ as const zstring ptr) as const zstring ptr
declare function sfHttpResponse_getStatus(byval httpResponse as const sfHttpResponse ptr) as sfHttpStatus
declare function sfHttpResponse_getMajorVersion(byval httpResponse as const sfHttpResponse ptr) as ulong
declare function sfHttpResponse_getMinorVersion(byval httpResponse as const sfHttpResponse ptr) as ulong
declare function sfHttpResponse_getBody(byval httpResponse as const sfHttpResponse ptr) as const zstring ptr
declare function sfHttp_create() as sfHttp ptr
declare sub sfHttp_destroy(byval http as sfHttp ptr)
declare sub sfHttp_setHost(byval http as sfHttp ptr, byval host as const zstring ptr, byval port as ushort)
declare function sfHttp_sendRequest(byval http as sfHttp ptr, byval request as const sfHttpRequest ptr, byval timeout as sfTime) as sfHttpResponse ptr

declare function sfPacket_create() as sfPacket ptr
declare function sfPacket_copy(byval packet as const sfPacket ptr) as sfPacket ptr
declare sub sfPacket_destroy(byval packet as sfPacket ptr)
declare sub sfPacket_append(byval packet as sfPacket ptr, byval data_ as const any ptr, byval sizeInBytes as uinteger)
declare sub sfPacket_clear(byval packet as sfPacket ptr)
declare function sfPacket_getData(byval packet as const sfPacket ptr) as const any ptr
declare function sfPacket_getDataSize(byval packet as const sfPacket ptr) as uinteger
declare function sfPacket_endOfPacket(byval packet as const sfPacket ptr) as sfBool
declare function sfPacket_canRead(byval packet as const sfPacket ptr) as sfBool
declare function sfPacket_readBool(byval packet as sfPacket ptr) as sfBool
declare function sfPacket_readInt8(byval packet as sfPacket ptr) as sfInt8
declare function sfPacket_readUint8(byval packet as sfPacket ptr) as sfUint8
declare function sfPacket_readInt16(byval packet as sfPacket ptr) as sfInt16
declare function sfPacket_readUint16(byval packet as sfPacket ptr) as sfUint16
declare function sfPacket_readInt32(byval packet as sfPacket ptr) as sfInt32
declare function sfPacket_readUint32(byval packet as sfPacket ptr) as sfUint32
declare function sfPacket_readFloat(byval packet as sfPacket ptr) as single
declare function sfPacket_readDouble(byval packet as sfPacket ptr) as double
declare sub sfPacket_readString(byval packet as sfPacket ptr, byval string_ as zstring ptr)
declare sub sfPacket_readWideString(byval packet as sfPacket ptr, byval string_ as wstring ptr)
declare sub sfPacket_writeBool(byval packet as sfPacket ptr, byval as sfBool)
declare sub sfPacket_writeInt8(byval packet as sfPacket ptr, byval as sfInt8)
declare sub sfPacket_writeUint8(byval packet as sfPacket ptr, byval as sfUint8)
declare sub sfPacket_writeInt16(byval packet as sfPacket ptr, byval as sfInt16)
declare sub sfPacket_writeUint16(byval packet as sfPacket ptr, byval as sfUint16)
declare sub sfPacket_writeInt32(byval packet as sfPacket ptr, byval as sfInt32)
declare sub sfPacket_writeUint32(byval packet as sfPacket ptr, byval as sfUint32)
declare sub sfPacket_writeFloat(byval packet as sfPacket ptr, byval as single)
declare sub sfPacket_writeDouble(byval packet as sfPacket ptr, byval as double)
declare sub sfPacket_writeString(byval packet as sfPacket ptr, byval string_ as const zstring ptr)
declare sub sfPacket_writeWideString(byval packet as sfPacket ptr, byval string_ as const wstring ptr)

declare function sfSocketSelector_create() as sfSocketSelector ptr
declare function sfSocketSelector_copy(byval selector as const sfSocketSelector ptr) as sfSocketSelector ptr
declare sub sfSocketSelector_destroy(byval selector as sfSocketSelector ptr)
declare sub sfSocketSelector_addTcpListener(byval selector as sfSocketSelector ptr, byval socket as sfTcpListener ptr)
declare sub sfSocketSelector_addTcpSocket(byval selector as sfSocketSelector ptr, byval socket as sfTcpSocket ptr)
declare sub sfSocketSelector_addUdpSocket(byval selector as sfSocketSelector ptr, byval socket as sfUdpSocket ptr)
declare sub sfSocketSelector_removeTcpListener(byval selector as sfSocketSelector ptr, byval socket as sfTcpListener ptr)
declare sub sfSocketSelector_removeTcpSocket(byval selector as sfSocketSelector ptr, byval socket as sfTcpSocket ptr)
declare sub sfSocketSelector_removeUdpSocket(byval selector as sfSocketSelector ptr, byval socket as sfUdpSocket ptr)
declare sub sfSocketSelector_clear(byval selector as sfSocketSelector ptr)
declare function sfSocketSelector_wait(byval selector as sfSocketSelector ptr, byval timeout as sfTime) as sfBool
declare function sfSocketSelector_isTcpListenerReady(byval selector as const sfSocketSelector ptr, byval socket as sfTcpListener ptr) as sfBool
declare function sfSocketSelector_isTcpSocketReady(byval selector as const sfSocketSelector ptr, byval socket as sfTcpSocket ptr) as sfBool
declare function sfSocketSelector_isUdpSocketReady(byval selector as const sfSocketSelector ptr, byval socket as sfUdpSocket ptr) as sfBool

type sfSocketStatus as long
enum
	sfSocketDone
	sfSocketNotReady
	sfSocketDisconnected
	sfSocketError
end enum

declare function sfTcpListener_create() as sfTcpListener ptr
declare sub sfTcpListener_destroy(byval listener as sfTcpListener ptr)
declare sub sfTcpListener_setBlocking(byval listener as sfTcpListener ptr, byval blocking as sfBool)
declare function sfTcpListener_isBlocking(byval listener as const sfTcpListener ptr) as sfBool
declare function sfTcpListener_getLocalPort(byval listener as const sfTcpListener ptr) as ushort
declare function sfTcpListener_listen(byval listener as sfTcpListener ptr, byval port as ushort) as sfSocketStatus
declare function sfTcpListener_accept(byval listener as sfTcpListener ptr, byval connected as sfTcpSocket ptr ptr) as sfSocketStatus

declare function sfTcpSocket_create() as sfTcpSocket ptr
declare sub sfTcpSocket_destroy(byval socket as sfTcpSocket ptr)
declare sub sfTcpSocket_setBlocking(byval socket as sfTcpSocket ptr, byval blocking as sfBool)
declare function sfTcpSocket_isBlocking(byval socket as const sfTcpSocket ptr) as sfBool
declare function sfTcpSocket_getLocalPort(byval socket as const sfTcpSocket ptr) as ushort
declare function sfTcpSocket_getRemoteAddress(byval socket as const sfTcpSocket ptr) as sfIpAddress
declare function sfTcpSocket_getRemotePort(byval socket as const sfTcpSocket ptr) as ushort
declare function sfTcpSocket_connect(byval socket as sfTcpSocket ptr, byval host as sfIpAddress, byval port as ushort, byval timeout as sfTime) as sfSocketStatus
declare sub sfTcpSocket_disconnect(byval socket as sfTcpSocket ptr)
declare function sfTcpSocket_send(byval socket as sfTcpSocket ptr, byval data_ as const any ptr, byval size as uinteger) as sfSocketStatus
declare function sfTcpSocket_receive(byval socket as sfTcpSocket ptr, byval data_ as any ptr, byval maxSize as uinteger, byval sizeReceived as uinteger ptr) as sfSocketStatus
declare function sfTcpSocket_sendPacket(byval socket as sfTcpSocket ptr, byval packet as sfPacket ptr) as sfSocketStatus
declare function sfTcpSocket_receivePacket(byval socket as sfTcpSocket ptr, byval packet as sfPacket ptr) as sfSocketStatus

declare function sfUdpSocket_create() as sfUdpSocket ptr
declare sub sfUdpSocket_destroy(byval socket as sfUdpSocket ptr)
declare sub sfUdpSocket_setBlocking(byval socket as sfUdpSocket ptr, byval blocking as sfBool)
declare function sfUdpSocket_isBlocking(byval socket as const sfUdpSocket ptr) as sfBool
declare function sfUdpSocket_getLocalPort(byval socket as const sfUdpSocket ptr) as ushort
declare function sfUdpSocket_bind(byval socket as sfUdpSocket ptr, byval port as ushort) as sfSocketStatus
declare sub sfUdpSocket_unbind(byval socket as sfUdpSocket ptr)
declare function sfUdpSocket_send(byval socket as sfUdpSocket ptr, byval data_ as const any ptr, byval size as uinteger, byval address as sfIpAddress, byval port as ushort) as sfSocketStatus
declare function sfUdpSocket_receive(byval socket as sfUdpSocket ptr, byval data_ as any ptr, byval maxSize as uinteger, byval sizeReceived as uinteger ptr, byval address as sfIpAddress ptr, byval port as ushort ptr) as sfSocketStatus
declare function sfUdpSocket_sendPacket(byval socket as sfUdpSocket ptr, byval packet as sfPacket ptr, byval address as sfIpAddress, byval port as ushort) as sfSocketStatus
declare function sfUdpSocket_receivePacket(byval socket as sfUdpSocket ptr, byval packet as sfPacket ptr, byval address as sfIpAddress ptr, byval port as ushort ptr) as sfSocketStatus
declare function sfUdpSocket_maxDatagramSize() as ulong

End extern
